diff --git a/doc/guides/howto/telemetry.rst b/doc/guides/howto/telemetry.rst
index cf73dc41ce..8f4fa1a510 100644
--- a/doc/guides/howto/telemetry.rst
+++ b/doc/guides/howto/telemetry.rst
@@ -9,10 +9,6 @@ The Telemetry library provides users with the ability to query DPDK for
 telemetry information, currently including information such as ethdev stats,
 ethdev port list, and eal parameters.

-.. Note::
-
-   This library is experimental and the output format may change in the future.
-

 Telemetry Interface
 -------------------
diff --git a/lib/telemetry/rte_telemetry.h b/lib/telemetry/rte_telemetry.h
index 8776998b54..d3c61ffcd3 100644
--- a/lib/telemetry/rte_telemetry.h
+++ b/lib/telemetry/rte_telemetry.h
@@ -24,10 +24,6 @@
  *
  * RTE Telemetry.
  *
- * @warning
- * @b EXPERIMENTAL:
- * All functions in this file may be changed or removed without prior notice.
- *
  * The telemetry library provides a method to retrieve statistics from
  * DPDK by sending a request message over a socket. DPDK will send
  * a JSON encoded response containing telemetry data.
@@ -59,7 +55,6 @@ enum rte_tel_value_type {
  * @return
  *   0 on success, negative errno on error
  */
-__rte_experimental
 int
 rte_tel_data_start_array(struct rte_tel_data *d, enum rte_tel_value_type type);

@@ -71,7 +66,6 @@ rte_tel_data_start_array(struct rte_tel_data *d, enum rte_tel_value_type type);
  * @return
  *   0 on success, negative errno on error
  */
-__rte_experimental
 int
 rte_tel_data_start_dict(struct rte_tel_data *d);

@@ -85,7 +79,6 @@ rte_tel_data_start_dict(struct rte_tel_data *d);
  * @return
  *   0 on success, negative errno on error, E2BIG on string truncation
  */
-__rte_experimental
 int
 rte_tel_data_string(struct rte_tel_data *d, const char *str);

@@ -101,7 +94,6 @@ rte_tel_data_string(struct rte_tel_data *d, const char *str);
  * @return
  *   0 on success, negative errno on error, E2BIG on string truncation
  */
-__rte_experimental
 int
 rte_tel_data_add_array_string(struct rte_tel_data *d, const char *str);

@@ -117,7 +109,6 @@ rte_tel_data_add_array_string(struct rte_tel_data *d, const char *str);
  * @return
  *   0 on success, negative errno on error
  */
-__rte_experimental
 int
 rte_tel_data_add_array_int(struct rte_tel_data *d, int x);

@@ -133,7 +124,6 @@ rte_tel_data_add_array_int(struct rte_tel_data *d, int x);
  * @return
  *   0 on success, negative errno on error
  */
-__rte_experimental
 int
 rte_tel_data_add_array_u64(struct rte_tel_data *d, uint64_t x);

@@ -154,7 +144,6 @@ rte_tel_data_add_array_u64(struct rte_tel_data *d, uint64_t x);
  * @return
  *   0 on success, negative errno on error
  */
-__rte_experimental
 int
 rte_tel_data_add_array_container(struct rte_tel_data *d,
 		struct rte_tel_data *val, int keep);
@@ -173,7 +162,6 @@ rte_tel_data_add_array_container(struct rte_tel_data *d,
  *   0 on success, negative errno on error, E2BIG on string truncation of
  *   either name or value.
  */
-__rte_experimental
 int
 rte_tel_data_add_dict_string(struct rte_tel_data *d, const char *name,
 		const char *val);
@@ -191,7 +179,6 @@ rte_tel_data_add_dict_string(struct rte_tel_data *d, const char *name,
  * @return
  *   0 on success, negative errno on error, E2BIG on string truncation of name.
  */
-__rte_experimental
 int
 rte_tel_data_add_dict_int(struct rte_tel_data *d, const char *name, int val);

@@ -208,7 +195,6 @@ rte_tel_data_add_dict_int(struct rte_tel_data *d, const char *name, int val);
  * @return
  *   0 on success, negative errno on error, E2BIG on string truncation of name.
  */
-__rte_experimental
 int
 rte_tel_data_add_dict_u64(struct rte_tel_data *d,
 		const char *name, uint64_t val);
@@ -232,7 +218,6 @@ rte_tel_data_add_dict_u64(struct rte_tel_data *d,
  * @return
  *   0 on success, negative errno on error
  */
-__rte_experimental
 int
 rte_tel_data_add_dict_container(struct rte_tel_data *d, const char *name,
 		struct rte_tel_data *val, int keep);
@@ -285,7 +270,6 @@ typedef void * (*handler)(void *sock_id);
  *  @return
  *  -ENOMEM for mem allocation failure.
  */
-__rte_experimental
 int
 rte_telemetry_register_cmd(const char *cmd, telemetry_cb fn, const char *help);

@@ -297,7 +281,6 @@ rte_telemetry_register_cmd(const char *cmd, telemetry_cb fn, const char *help);
  * @return
  *  Pointer to a container.
  */
-__rte_experimental
 struct rte_tel_data *
 rte_tel_data_alloc(void);

@@ -309,7 +292,6 @@ rte_tel_data_alloc(void);
  *  Pointer to container.
  *.
  */
-__rte_experimental
 void
 rte_tel_data_free(struct rte_tel_data *data);

diff --git a/lib/telemetry/version.map b/lib/telemetry/version.map
index bde80ce29b..77528bb1fe 100644
--- a/lib/telemetry/version.map
+++ b/lib/telemetry/version.map
@@ -1,4 +1,4 @@
-EXPERIMENTAL {
+DPDK_22 {
 	global:

 	rte_tel_data_add_array_container;