diff --git a/doc/guides/howto/lm_bond_virtio_sriov.rst b/doc/guides/howto/lm_bond_virtio_sriov.rst
index 3e25480316..e854ae214e 100644
--- a/doc/guides/howto/lm_bond_virtio_sriov.rst
+++ b/doc/guides/howto/lm_bond_virtio_sriov.rst
@@ -392,7 +392,7 @@ Set up Virtual Functions on host_server_1
    cat /sys/bus/pci/devices/0000\:02\:00.0/sriov_numvfs
    echo 1 > /sys/bus/pci/devices/0000\:02\:00.0/sriov_numvfs
    cat /sys/bus/pci/devices/0000\:02\:00.0/sriov_numvfs
-   rmmod i40evf
+   rmmod iavf
 
 vm_virtio_vf_one_212_46.sh
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -492,7 +492,7 @@ Set up Virtual Functions on host_server_2
    cat /sys/bus/pci/devices/0000\:03\:00.0/sriov_numvfs
    echo 1 > /sys/bus/pci/devices/0000\:03\:00.0/sriov_numvfs
    cat /sys/bus/pci/devices/0000\:03\:00.0/sriov_numvfs
-   rmmod i40evf
+   rmmod iavf
 
 vm_virtio_one_migrate.sh
 ~~~~~~~~~~~~~~~~~~~~~~~~
diff --git a/doc/guides/nics/features/i40e_vf.ini b/doc/guides/nics/features/i40e_vf.ini
deleted file mode 100644
index 36d7136d13..0000000000
--- a/doc/guides/nics/features/i40e_vf.ini
+++ /dev/null
@@ -1,40 +0,0 @@
-;
-; Supported features of the 'i40e_vf' network poll mode driver.
-;
-; Refer to default.ini for the full list of available PMD features.
-;
-[Features]
-Rx interrupt         = Y
-Link status          = Y
-Link status event    = Y
-Fast mbuf free       = P
-Queue start/stop     = Y
-Power mgmt address monitor = Y
-Jumbo frame          = Y
-Scattered Rx         = Y
-TSO                  = Y
-Promiscuous mode     = Y
-Allmulticast mode    = Y
-Unicast MAC filter   = Y
-Multicast MAC filter = Y
-RSS hash             = Y
-RSS key update       = Y
-RSS reta update      = Y
-VLAN filter          = Y
-CRC offload          = Y
-VLAN offload         = Y
-QinQ offload         = P
-L3 checksum offload  = P
-L4 checksum offload  = P
-Inner L3 checksum    = P
-Inner L4 checksum    = P
-Packet type parsing  = Y
-Rx descriptor status = Y
-Tx descriptor status = Y
-Basic stats          = Y
-Extended stats       = Y
-Multiprocess aware   = Y
-FreeBSD              = Y
-Linux                = Y
-x86-32               = Y
-x86-64               = Y
diff --git a/doc/guides/nics/intel_vf.rst b/doc/guides/nics/intel_vf.rst
index fcea8151bf..b80c41809b 100644
--- a/doc/guides/nics/intel_vf.rst
+++ b/doc/guides/nics/intel_vf.rst
@@ -26,7 +26,7 @@ Refer to :numref:`figure_single_port_nic`.
 
 Therefore, a NIC is logically distributed among multiple virtual machines (as shown in :numref:`figure_single_port_nic`),
 while still having global data in common to share with the Physical Function and other Virtual Functions.
-The DPDK fm10kvf, i40evf, igbvf or ixgbevf as a Poll Mode Driver (PMD) serves for the Intel® 82576 Gigabit Ethernet Controller,
+The DPDK fm10kvf, iavf, igbvf or ixgbevf as a Poll Mode Driver (PMD) serves for the Intel® 82576 Gigabit Ethernet Controller,
 Intel® Ethernet Controller I350 family, Intel® 82599 10 Gigabit Ethernet Controller NIC,
 Intel® Fortville 10/40 Gigabit Ethernet Controller NIC's virtual PCI function, or PCIe host-interface of the Intel Ethernet Switch
 FM10000 Series.
@@ -88,12 +88,6 @@ For more detail on SR-IOV, please refer to the following documents:
     assignment in hypervisor. Take qemu for example, the device assignment should carry the IAVF device id (0x1889) like
     ``-device vfio-pci,x-pci-device-id=0x1889,host=03:0a.0``.
 
-    Starting from DPDK 21.05, the default VF driver for Intel® 700 Series Ethernet Controller will be IAVF. No new feature
-    will be added into i40evf except bug fix until it's removed in DPDK 21.11. Between DPDK 21.05 and 21.11, by using the
-    ``devargs`` option ``driver=i40evf``, i40evf PMD still can be used on Intel® 700 Series Ethernet Controller, for example::
-
-    -a 81:02.0,driver=i40evf
-
     When IAVF is backed by an Intel® E810 device, the "Protocol Extraction" feature which is supported by ice PMD is also
     available for IAVF PMD. The same devargs with the same parameters can be applied to IAVF PMD, for detail please reference
     the section ``Protocol extraction for per queue`` of ice.rst.
diff --git a/doc/guides/rel_notes/deprecation.rst b/doc/guides/rel_notes/deprecation.rst
index 59445a6f42..d0a65d3f46 100644
--- a/doc/guides/rel_notes/deprecation.rst
+++ b/doc/guides/rel_notes/deprecation.rst
@@ -164,14 +164,6 @@ Deprecation Notices
   consistent with existing outer header checksum status flag naming, which
   should help in reducing confusion about its usage.
 
-* i40e: As there are both i40evf and iavf pmd, the functions of them are
-  duplicated. And now more and more advanced features are developed on iavf.
-  To keep consistent with kernel driver's name
-  (https://patchwork.ozlabs.org/patch/970154/), i40evf is no need to maintain.
-  Starting from 21.05, the default VF driver of i40e will be iavf, but i40evf
-  can still be used if users specify the devarg "driver=i40evf". I40evf will
-  be deleted in DPDK 21.11.
-
 * net: ``s_addr`` and ``d_addr`` fields of ``rte_ether_hdr`` structure
   will be renamed in DPDK 21.11 to avoid conflict with Windows Sockets headers.
 
diff --git a/doc/guides/rel_notes/release_21_11.rst b/doc/guides/rel_notes/release_21_11.rst
index 19356ac53c..77e8af1833 100644
--- a/doc/guides/rel_notes/release_21_11.rst
+++ b/doc/guides/rel_notes/release_21_11.rst
@@ -126,6 +126,8 @@ Removed Items
   blacklist/whitelist are removed. Users must use the new
   block/allow list arguments.
 
+* i40e: Removed i40evf driver. Due to iavf already became the default VF
+  driver for i40e devices, so remove i40evf due to it's no need to maintain.
 
 API Changes
 -----------